*;
*  First attempt at making an HTML file for Excel and Word.
*
*  Outcome: (1) Cell borders OK in Word and Excel
*           (2) Green background OK in Word, mapped to gray in Excel
*           (3) Dates formatted correctly in Word, different in Excel
*           (4) Leading zeroes retained in Word, dropped in Excel
*;

*  Use ODS to create the HTML file;

ods listing close;
ods tagsets.MSOffice2K style=Banker path="&OUTDIR" file='aedata.htm';
  title; footnote;
  proc print data=pharma.phcae noobs label;
    by protocol;
    var patient visit aedate aecode aetext aesev aesevc frequency;
  run; quit;

  proc tabulate data=pharma.phcae;
    by protocol;
    var aesev;
    class aetext aesevc;
    table aetext*aesevc,aesev*pctn;
    keyword all pctn;
    keylabel pctn='Percent';
  run; quit;
ods tagsets.MSOffice2K close;
