*;
*  Final attempt at making an HTML file for Excel and Word.
*
*  Outcome: (1) Cell borders still OK in Word and Excel
*           (2) Green background now OK in both Word and Excel
*           (3) Dates are still formatted correctly in Excel
*           (4) Leading zeroes still retained in Excel
*;

*  Use ODS to create the HTML file, with a new style and style overrides applied;

*** TO DO: Change style name from Banker to MSOBanker ;

ods listing close;
ods tagsets.MSOffice2K style=Banker path="&OUTDIR" file='aedata.htm';
  title; footnote;
  proc print data=pharma.phcae noobs label;
    by protocol;
    var patient visit;
    var aedate / style={htmlstyle="mso-number-format:ddmmmyyyy"};
    var aecode / style={htmlstyle="mso-number-format:00000000"};
    var aetext aesev aesevc frequency;
  run; quit;

  proc tabulate data=pharma.phcae;
    by protocol;
    var aesev;
    class aetext aesevc;
    table aetext*aesevc,aesev*pctn;
    keyword all pctn;
    keylabel pctn='Percent';
  run; quit;
ods tagsets.MSOffice2K close;
