*;
*  Second attempt at making an XML file for Excel.
*
*  Outcome: (1) Cell borders are still missing
*           (2) Green background is still OK
*           (3) Leading zeroes are retained
*;

*  Use ODS to create the XML file;

ods listing close;
ods tagsets.ExcelXP style=MSOBanker path="&OUTDIR" file='aedata.xml';
  title; footnote;
  proc print data=pharma.phcae noobs label;
    by protocol;
    var patient visit aedate;
    var aecode / style={tagattr="\00000000"};
    var aetext aesev aesevc frequency;
  run; quit;

  proc tabulate data=pharma.phcae;
    by protocol;
    var aesev;
    class aetext aesevc;
    table aetext*aesevc,aesev*pctn;
    keyword all pctn;
    keylabel pctn='Percent';
  run; quit;
ods tagsets.ExcelXP close;
