*;
*  Final attempt at making an XML file for Excel.
*
*  Outcome: (1) Cell borders are now present
*           (2) Green background is still OK
*           (3) Leading zeroes are still retained
*;

*  Use ODS to create the XML file;

*** TO DO: Change the style name from MSOBanker to XLBanker ;

ods listing close;
ods tagsets.ExcelXP style=MSOBanker path="&OUTDIR" file='aedata.xml';
  title; footnote;
  proc print data=pharma.phcae noobs label;
    by protocol;
    var patient visit aedate;
    var aecode / style={tagattr="\00000000"};
    var aetext aesev aesevc frequency;
  run; quit;

  proc tabulate data=pharma.phcae;
    by protocol;
    var aesev;
    class aetext aesevc;
    table aetext*aesevc,aesev*pctn;
    keyword all pctn;
    keylabel pctn='Percent';
  run; quit;
ods tagsets.ExcelXP close;
